#include <iostream>

using namespace std;

const int LONG_MONTH = 31, SHORT_MONTH = 30, LEAP_FEB = 29, NORMAL_FEB = 28;

int printMonthCalender(int numOfDays, int startingDay);

bool leapYear(int year);

void printYearCalender(int year, int startingDay);

int main() {
    int year, startingDay;

    cout << "Enter a year: ";
    cin >> year;
    cout << "Enter the starting day: ";
    cin >> startingDay;
    cout << endl;

    printYearCalender(year, startingDay);
    return 0;
}

int printMonthCalender(int numOfDays, int startingDay) {
    cout << "Mon\tTue\tWed\tThr\tFri\tSat\tSun\t\n";

    for (int i = 1; i < numOfDays + startingDay; ++i) {
        if (i - startingDay >= 0) cout << i - startingDay + 1 << "\t";
        else cout << " \t";

        if (i % 7 == 0) cout << endl;
    }
    cout << "\n\n";

    int statusCode = (numOfDays + startingDay - 1) % 7;
    return statusCode == 0 ? 7 : statusCode; //seventh day of the week (Sunday) has a remainder of 0, but it should return 7
}

bool leapYear(int year) {
    return ((year % 4 == 0 && year % 100 != 0) || year % 400 == 0);
}

void printYearCalender(int year, int startingDay) {
    cout << "January " << year << endl;
    startingDay = printMonthCalender(LONG_MONTH, startingDay) % 7 + 1;

    cout << "February " << year << endl;
    if (leapYear(year)) {
        startingDay = printMonthCalender(LEAP_FEB, startingDay) % 7 + 1;
    } else {
        startingDay = printMonthCalender(NORMAL_FEB, startingDay) % 7 + 1;
    }

    cout << "March " << year << endl;
    startingDay = printMonthCalender(LONG_MONTH, startingDay) % 7 + 1;

    cout << "April " << year << endl;
    startingDay = printMonthCalender(SHORT_MONTH, startingDay) % 7 + 1;

    cout << "May " << year << endl;
    startingDay = printMonthCalender(LONG_MONTH, startingDay) % 7 + 1;

    cout << "June " << year << endl;
    startingDay = printMonthCalender(SHORT_MONTH, startingDay) % 7 + 1;

    cout << "July " << year << endl;
    startingDay = printMonthCalender(LONG_MONTH, startingDay) % 7 + 1;

    cout << "August " << year << endl;
    startingDay = printMonthCalender(LONG_MONTH, startingDay) % 7 + 1;

    cout << "September " << year << endl;
    startingDay = printMonthCalender(SHORT_MONTH, startingDay) % 7 + 1;

    cout << "October " << year << endl;
    startingDay = printMonthCalender(LONG_MONTH, startingDay) % 7 + 1;

    cout << "November " << year << endl;
    startingDay = printMonthCalender(SHORT_MONTH, startingDay) % 7 + 1;

    cout << "December " << year << endl;
    printMonthCalender(LONG_MONTH, startingDay);
}

